#lang racket/base (require racket/contract (submod  "../snack/contract.rkt" core))

(provide with-locals
         (contract-out [definitions (parameter/c definitions/c)]
                       [♯binding (syntax? . → . (♯ syntax?))]
                       [substitute ((listof identifier?) (listof syntax?) syntax? . → . syntax?)]))

(define definitions/c (listof syntax?))

(require (only-in "patterns.rkt" Define)
                           
         (only-in "../snack/list.rkt" find-first)
         (submod "../snack/syntax.rkt")
         (submod "../snack/syntax.rkt" syntax-classes/core))

(define definitions (make-parameter '()))

(define-macro (with-locals some-definitions:expr body:expr ...+) 
  (parameterize ([definitions (append (definitions) some-definitions)])
    body ...))

(define (♯binding an-id #:definitions [the-definitions (definitions)])
  (find-first (♯syntax-parser [:Define (alias? an-id (α name))]) (reverse the-definitions)))

(define (substitute parameters arguments body)
  (for/fold ([body body]) ([parameter parameters] [argument arguments])
    ((sub parameter argument) body)))

(define/contract (sub an-id replacement) (identifier? syntax? . → . (syntax? . → . syntax?))
  (syntax-parser
    [(part ...) (syn (map (sub an-id replacement) (α part)))]
    [name:id #:when (alias? an-id (α name)) replacement]
    [_ this-syntax]))
