#lang racket

; Boxes and Mutation
; ==================
(provide (rename-out (make-Box Box))
         Box-content
         Box-identity
         Box-set-content
         Box?)

(define-syntax-rule (Box-set-content b e)
  (let () (set-Box-content! b e)
    (Box-content b)))

(define make-Box (local [(define id -1)]
                   (λ (content)
                     (set! id (add1 id))
                     (Box id content))))

(struct Box (identity [content #:mutable]) #:transparent
  #:property prop:object-name (λ (self) (list (string->symbol (format "Box.~a" (Box-identity self)))
                                              ':
                                              (Box-content self))))
