#lang racket/base #| Currently: syntactic context |#

(provide (all-defined-out))

(define (top?) (or (definitions-top?) (interactions-top?)))
(define (interactions-top?) (member (syntax-local-context) '(top-level)))
(define (definitions-top?)  (member (syntax-local-context) '(module module-begin)))

(require syntax/parse racket/lazy-require)

(lazy-require [(submod "../../english.rkt" syntax) ([non-top message:non-top])])

(define (⌢:non-top this-syntax)
  (define name-from (syntax-parser [(~or* name:id (name:id . _)) #'name]))
  (define (syntax-error stx msg [detail #false]) (raise-syntax-error #false msg stx detail))
  (syntax-error this-syntax (message:non-top (name-from this-syntax))))

(define-syntax-class ⌢non-top (pattern _ #:when (not (top?)) #:do (⌢:non-top this-syntax)))
