#lang racket/base (provide (rename-out [compthink:big-bang big-bang]))

(require "../../snack/syntax.rkt" (for-syntax syntax/stx))

(begin-for-syntax
  
  ; Shared state for syntax errors.
  (require "syntax-error-context.rkt")

  (require "../../snack/syntax.rkt")
  (define-syntax-parser parser/⊥
    [(_ (~optional (~seq #:arity ⌢)) part ...+)
     #'(λ (stx) (parameterize [(context stx)]
                  (syntax-parse stx part ...
                    (~? [(_ . :sequence) (⌢ (attribute length))])
                    [_ (⌢:bare/weird)])))])

  ; Will lazily require most static error handling.
  (require racket/lazy-require)
  (lazy-require ["syntax-error.rkt" (⌢:bare/weird ⌢:big-bang:arity)])

  ; Standard definitions.
  (define-syntax-class sequence (pattern (_ ...) #:attr length (length (stx->list this-syntax)))))

(define (view v) v)

(define-syntax compthink:big-bang
  (parser/⊥ #:arity ⌢:big-bang:arity
            #;[_ #'(void)]
            [(_ model:expr (~and clause [kw . args]) ...)
             #:when (not (ormap (♯syntax-parser [((~datum #;~literal to-draw) . _) #true])
                                (stx->list #'(clause ...))))
             #:with import #'(local-require
                              (only-in 2htdp/universe
                                       big-bang
                                       to-draw on-tick
                                       on-key on-mouse key-event? key=? mouse-event? mouse=?
                                       state
                                       stop-when
                                       record?))
             #:with (big-bang to-draw) (datum->syntax #'import '(big-bang to-draw))           
             #:with (kw′ ...) (datum->syntax #'import (syntax->datum #'(kw ...)))
             (quasisyntax/loc this-syntax (let () import
                                            (big-bang model [to-draw view] [kw′ . args] ...)))]
            [(_ part.0 part ...)
             (syntax-local-lift-require '(only 2htdp/universe
                                               to-draw on-tick
                                               on-key on-mouse key-event? key=? mouse-event? mouse=?
                                               state
                                               stop-when
                                               record?)
                                        (syntax-local-lift-require
                                         '(rename 2htdp/universe #%big-bang big-bang)
                                         #'(#%big-bang part.0 part ...)))]
            #;(syntax/loc this-syntax
                (let () (local-require (only-in 2htdp/universe big-bang))
                  big-bang))))
