#lang racket/base

(provide compthink-comments@)

;    private/comments-tool.rkt: (define comment-out-selection-mixin
;    private/comments-tool.rkt:     (define/override (comment-out-selection [start-pos (get-start-position)]
;    private/comments-tool.rkt:   (drracket:get/extend:extend-definitions-text comment-out-selection-mixin))
; private/keybindings-tool.rkt:   #;(set-shortcut racket-menu (list (string-constant semicolon-comment-out-menu-item-label)) #\;)
; private/keybindings-tool.rkt:   (set-shortcut racket-menu (list (string-constant box-comment-out-menu-item-label)) #\:
;             private/text.rkt:         (send racket-text comment-out-selection start end)

; private/keybindings-tool.rkt:   (add (default-modifier "semicolon") "line comment/uncomment around selection" un/comment-selection)
;      private/language-ui.rkt:                     (command "line comment/uncomment around selection")
;             private/text.rkt:         (send racket-text uncomment-selection   start end)))

; private/keybindings-tool.rkt:   (add (default-modifier "semicolon") "line comment/uncomment around selection" un/comment-selection)
;             private/text.rkt: (module* commands #false (provide surrounder un/comment-selection
;             private/text.rkt:   (define-for-racket-text-event (un/comment-selection racket-text)

(require "text.rkt" (submod "../snack/class.rkt" implement)
         #;(only-in racket/class mixin class->interface inherit super-new define/override this))

(define comment-out-selection-mixin
  (mixin (racket:text<%>) ()
    (inherit get-start-position get-end-position paragraph-start-position position-paragraph
             insert set-position)
    (super-new)
    (define (paragraph-start position) (paragraph-start-position (position-paragraph position)))
    (define/override (comment-out-selection [start-pos (get-start-position)]
                                            [end-pos   (get-end-position)])
      (edit-sequence this
        (define start-paragraph-start (paragraph-start start-pos))
        (define end-pos′ (max start-pos (sub1 end-pos)))
        (for ([paragraph (in-range (position-paragraph start-pos)
                                   (add1 (position-paragraph end-pos′)))])
          (insert "; " (paragraph-start-position paragraph)))
        (when (= start-pos start-paragraph-start)
          (set-position start-paragraph-start (get-end-position)))))))

(require drracket/tool racket/unit)
(define-unit compthink-comments@ (import drracket:tool^) (export)
  (drracket:get/extend:extend-definitions-text comment-out-selection-mixin))
