#lang racket/base (require (submod "snack/contract.rkt" core))

(define/contract-out suppress-type-prefix (parameter/c boolean?) (make-parameter #false))

(module step racket/base (require (submod "snack/contract.rkt" core)
                                  (submod "english.rkt" ui)
                                  "snack/preferences.rkt"
                                  (only-in racket/dict in-dict))

  (provide (prefix-out preference: (contract-out [display:underline:next  boolean-preference/c]
                                                 [display:spacing:compact boolean-preference/c]
                                                 [interaction:no-wait     boolean-preference/c]))
           in-dict)
  (define (preference-name name) (format-symbol "drracket:compthink:step:~a?" name))
  (define-values (display:underline:next display:spacing:compact interaction:no-wait)
    (values (boolean-preference (preference-name 'display:underline:next) #true)
            (boolean-preference (preference-name 'display:spacing:compact))
            (boolean-preference (preference-name 'interaction:no-wait))))
  (define/contract-out step:labels (listof (cons/c boolean-preference/c string?))
    (list (cons display:underline:next  message:display:underline:next)
          (cons display:spacing:compact message:display:spacing:compact)
          (cons interaction:no-wait     message:interaction:no-wait))))
