#lang racket/base (provide syntax→code syntax→code′)

(require syntax/parse syntax/stx)

(define (function-representation f)
  (define name (object-name f))
  (if name name f))

(define syntax→code′
  (syntax-parser #:literals (quote)
                 [(quote (e:expr ...)) #`(list . #,(stx-map syntax→code′ #'('e ...)))]
                 [(quote e:expr) (define datum (syntax->datum #'e))
                                 #`#,(cond [(procedure? datum) (function-representation datum)]
                                       [(list? (object-name datum)) (object-name datum)]
                                       [else datum])]
                 [(_ ...) #`#,(stx-map syntax→code′ this-syntax)]
                 [_ this-syntax #;(syntax->datum this-syntax)]))

(define syntax→code
  (syntax-parser #:literals (quote)
                 [(quote (e:expr ...)) `(list . ,(stx-map syntax→code #'('e ...)))]
                 [(quote e:expr) (define datum (syntax->datum #'e))
                                 (cond [(procedure? datum) (function-representation datum)]
                                       [(list? (object-name datum)) (object-name datum)]
                                       [else datum])]
                 [(_ ...) (stx-map syntax→code this-syntax)]
                 [_ (syntax->datum this-syntax)]))
