#lang racket/base (require (submod "contract.rkt" core))

(struct view (label bitmap position) #:transparent)

(define switchable-button%/c (is-a?/c switchable-button%))

(provide (contract-out
          (struct view ([label string?] [bitmap (is-a?/c bitmap%)] [position (♯ real?)]))
          [button ((is-a?/c panel% #;horizontal-panel%)
                   . → .
                   (view? (switchable-button%/c . → . any/c) . → . switchable-button%/c))]
          [show-button (switchable-button%/c #;subwindow<%> . → . void?)]
          [hide-button (switchable-button%/c #;subwindow<%> . → . void?)])
         container-edit-sequence
         read-bitmap)

(require (only-in mrlib/switchable-button switchable-button%)
         (only-in racket/gui/base panel% bitmap% read-bitmap)
         (submod "class.rkt" use) (submod "syntax.rkt" core))

(define ((button parent) view callback)
  (new switchable-button% [parent parent]
       [label (view-label view)] [bitmap (view-bitmap view)] [callback callback]))

(define-macro (container-edit-sequence container:expr body:expr ...+)
  ; ToDo: react to whether in definition context.
  ; ToDo: consider some sort of parameterization for use in the body.
  (begin (define container-value container)
         (send container-value begin-container-sequence)
         body ...
         (send container-value end-container-sequence)))

; For parent < area-container<%>, where this child (is-a?/c subwindow<%>).
(define (show-button button) (unless (send button is-shown?) (send+ button (get-parent)
                                                                    (add-child button))))
(define (hide-button button) (when   (send button is-shown?) (send+ button (get-parent)
                                                                    (delete-child button))))
