#lang racket 

(provide (all-defined-out))
(require (submod "syntax.rkt" core))
(define-syntax-parser type-case #:literals (else)
  [(_ e:expr
      [predicate?:expr body:expr ...+] ...+
      [else else-body:expr ...+])
   #'(let ([e-value e]) (cond [(predicate? e-value) body ...] ...
                              [else else-body ...]))]
  [(_ e:expr
      clause ...+
      [#:assert assertion:expr else-body:expr ...+])
   #'(let ([e-value e])
       (type-case e-value
         clause ...
         [assertion else-body ...]
         [else (raise-result-error 'type-case
                                   (format "assertion ~s to be true for ~e" 'assertion e-value)
                                   #false)]))])
