#lang racket/base #;(require racket/contract)

#;(provide (all-from-out 'core)
           (rename-out [define-struct/contract struct/contract])
           (except-out (all-from-out racket/contract)
                       provide/contract #;|deprecated|
                       define-module-boundary-contract contract #;|“low level”|)
           define/contract-out contracts define-flat-recursive-contracts)

(module core racket/base (require racket/contract/base)
  (provide (all-defined-out) (except-out (all-from-out racket/contract/base)
                                         provide/contract #;|deprecated|
                                         define-module-boundary-contract contract #;|“low level”|))
  (provide (rename-out [-> →] [->* →∗] [case-> case→]
                       [exact-positive-integer? positive-natural?]
                       [exact-positive-integer? positive-natural/c]
                       [exact-nonnegative-integer? natural/c]))
  (define positive-real/c (and/c real? positive?))
  (define (♯ contract) (or/c #false contract))
  #| Intended for proper list contracts, with at least two contracts, the final one a list contract.
   Otherwise: use ‘cons/c’ directly. |#
  (define (list*/c contract . contracts) (if (null? contracts)
                                             contract
                                             ; Relies on unary case as base case.
                                             (cons/c contract (apply list*/c contracts))))
  (define non-empty/c (list*/c any/c list?))
  (require syntax/parse/define)
  (define-simple-macro (define/contract-out id:id contract:expr initial:expr)
    (begin (provide (contract-out [id contract])) (define id initial))))

#;
(require 'core)
#;#;#;
(require (for-syntax syntax/parse/lib/function-header)
         (submod "syntax.rkt" core))

; Version of ‘flat-murec-contract’, that also defines the ids.
#;(define-flat-recursive-contracts (id:id ...+) (contract:expr ...+))
(define-macro (define-flat-recursive-contracts (id:id ...+) (contract:expr ...+))
  (define-values (id ...) (flat-murec-contract ([id contract] ...) (values id ...))))


(define-syntax-parser contracts
  [(_ (~or* [bind:id contract:expr]
            [~and [(bind:id args-contract-part ...) (~datum →) result-contract:expr]
                  (~bind [contract #'(-> args-contract-part ... result-contract)])]
            [~and [(bind:id args-contract-part ... [optional-args-contract-part ...])
                   (~datum →∗) result-contract:expr]
                  (~bind [contract #'(->* [args-contract-part ...] [optional-args-contract-part ...]
                                          result-contract)])])
      ...)
   #:with (contract′ ...) (generate-temporaries #'(contract ...))
   (syntax-property
    #`(begin (define contract′ contract)
             ...
             (define-syntax-parser #,(datum->syntax this-syntax 'define/c)
               [(_ (~and (~or* (~literal bind) ((~literal bind) . _)) bind′) . body:expr)
                (syntax-parse this-syntax
                  [(_ (~literal bind) init:expr)
                   #'(define/contract bind′ contract′ init)]
                  [(_ ((~and (~literal bind) bind′) . formals:formals) . body:expr)
                   #`(define/contract (bind′ . formals) contract′ . body)])]
               ...))
    ; The Racket Docs example uses syntax-local-introduce.
    'disappeared-use (map syntax-local-introduce (syntax->list #'(bind ...))))])
