#lang racket/base (provide generator)

(require (only-in racket/control shift-at reset-at))

(define (generator f)
  (in-producer (procedure->generator
                (let ([parameterization (current-parameterization)])
                  (λ (yield) (call-with-parameterization parameterization (λ () (f yield))))))
               stop))

(define stop (gensym 'stop))

(define (procedure->generator f)
  (define tag (make-continuation-prompt-tag))
  (define (cont) (reset-at tag
                           (f (λ (r) (shift-at tag k (set! cont k) r)))
                           (set! cont (λ () stop))
                           stop))
  (λ () (cont)))
