#lang racket/base (provide with-parent)

(require (submod "class.rkt" use)
         (submod "syntax.rkt" core) #;(for-syntax (submod "syntax.rkt" tooltip)) racket/local)

(define-syntax-parser with-parent 
  [(_ parent-expr:expr body:expr ...)
   #:with new′ (datum->syntax this-syntax 'new)
   (values #`(let ([parent-value parent-expr])
               (local [(... (define-macro (new′ class:expr [id:id init:expr] ...)
                              (new  class [parent parent-value] [id init] ...)))]
                 (void) body ...))
           #;"for guis: rebinds ‘new’ to implcitly include ‘[parent _]’\n")])
