#lang racket/base

(provide (all-from-out 'core))
;
(module core racket/base (provide (all-from-out racket/list)
                                  member?)
  (require (only-in racket/list
                    empty?
                    first second rest
                    append-map
                    flatten remove-duplicates
                    drop-right))
  (define (member? e l) (and (member e l) #true))
  (provide (rename-out [list* adjoin]
                       [list*-right adjoin-right]
                       [*list* adjoin-adjoin])
           rest-right list* list*-right *list*)
  (define (rest-right a-list) (drop-right a-list 1))
  (define (list*-right l e . es) (append l (list* e es)))
  (define (*list* element a-list element′) (list* element (list*-right a-list element′))))
;
(require 'core)

(provide § @ §.)

(struct @ (elements) #:transparent)
(define (§ . elements)
  (append-map (λ-match [(@ elements) elements] [element (list element)]) elements))
(define (§. . elements) (apply § (apply list* elements)))

(provide tabulate same-length?)
;
(require "match.rkt" (only-in racket/list take))
(define (tabulate . f⋯l)
  (match f⋯l
    [(list l) (list l)]
    [(list* f f⋯l) (define t′ (apply tabulate f⋯l))
                   (list* (apply map f (take t′ (procedure-arity f))) t′)]))

(define (same-length? ℓ.0 ℓ.1) (= (length ℓ.0) (length ℓ.1)))

(provide last partition filter-not third
         (rename-out [last first-right] [findf find-first] [append join]))
  
(require (only-in racket/list last partition filter-not third))
