#lang racket/base (require (submod "contract.rkt" core))

(provide write-special/display
         (contract-out [can-write-special? ([]  [output-port?] . →∗ . boolean?)]
                       (rename write-special′ ; For the ‘→ void?’ .
                               write-special ([any/c] [output-port?] . →∗ . void?))
                       [consume-available! (→ void?)]))

(require "lambda.rkt")

(define (consume-available!)
  (define available (with-handlers ([exn:fail? (λ₁ 1)]) (read-bytes-avail!* (bytes 0))))
  (unless (or (equal? 0 available) (eof-object? available)) (consume-available!)))

(define (can-write-special? [port (current-output-port)]) (port-writes-special? port))

(define (write-special′ v [port (current-output-port)]) (void (write-special v port)))

(require syntax/parse/define)

(define-simple-macro (write-special/display special:expr plain:expr)
  (if (can-write-special?) (write-special′ special) (display plain)))
