#lang racket/base #| Replacement for framework/preferences |# (require (submod "contract.rkt" core))

(provide boolean-preference/c
         (contract-out [boolean-preference ((symbol?) (any/c) . →∗ . boolean-preference/c)])
         preferences:set preferences:get preferences:default-set? preferences:set-default
         format-symbol)

#| Reprovide a useful core, and ‘format-symbol’ useful for making keys.
   Add a boolean preference maker, and associated contract for the returned getter-setter wrapper.
    The getter is safe to call even if the default isn't set. |#

(require framework/preferences (only-in racket/syntax format-symbol) "lambda.rkt")

(define boolean-preference/c (case→ (boolean? . → . void?) (→ boolean?)))

(define (boolean-preference preference-key [default #false])
  (case-λ [() (unless (preferences:default-set? preference-key)
                (preferences:set-default preference-key default boolean?))
              (preferences:get preference-key)]
          [(new-value) (preferences:set preference-key new-value)]))
