#lang racket/base #| Start of library to replace uses of racket/format and racket/string |#

(require (submod "contract.rkt" core)
         (only-in racket/format ~a ~s)
         (only-in racket/string string-prefix?))

(provide (all-from-out racket/format
                       racket/string)
         (rename-out [symbol->string ~symbol]
                     [string-append text-join])
         (contract-out [~a␣ (any/c ... . → . string?)]
                       [text-join-map (procedure? list? list? ... . → . string?)]))

(define/contract-out ␣ string? " ")
(define (~a␣ . vs) (apply ~a #:separator ␣ vs))
(define (text-join-map f . ℓs) (apply string-append (apply map f ℓs)))

(define/contract-out space:hair         string? "\U200A")
(define/contract-out space:thin         string? "\U2009")
(define/contract-out space:six-per-em   string? "\U2006")
(define/contract-out space:four-per-em  string? "\U2005")
(define/contract-out space:three-per-em string? "\U2004")
 