#lang racket/base (require (submod "contract.rkt" core))

(provide (contract-out [underlining (boolean? . → . style-delta%/c)]
                       [delta:underline             style-delta%/c]
                       [delta:bold                  style-delta%/c]
                       [delta:underline-bold        style-delta%/c]
                       [syntax-style (symbol? . → . string?)])
         string-snip)
  
(require (only-in framework
                  editor:get-standard-style-list
                  editor:get-default-color-style-name)
         (only-in racket/gui/base string-snip% style-delta%)
         "class.rkt")
(define framework:syntax-color:scheme: "framework:syntax-color:scheme:")

(define style-delta%/c (is-a?/c style-delta%))

(define (underlining on?) (make-object style-delta% 'change-underline on?))
(define delta:underline (make-object style-delta% 'change-underline #true))
(define delta:bold      (make-object style-delta% 'change-bold))
(define delta:underline-bold (send (make-object style-delta% 'change-underline #true)
                                   set-delta 'change-bold))

(define (syntax-style token-type) (string-append framework:syntax-color:scheme:
                                                 (symbol->string token-type)))
(define (string-snip string
                     [style-name (editor:get-default-color-style-name)]
                     #:delta♯ [delta♯ #false])
  (define snip (make-object string-snip% string))
  (define styles (editor:get-standard-style-list))
  (define style (send styles find-named-style style-name))
  (send/return snip set-style (if delta♯ (send styles find-or-create-style style delta♯) style)))
